Bug 15381 - Incorrect "Applies To" line for 'overflow' property (Error in resolution for Issue 120)
Incorrect "Applies To" line for 'overflow' property (Error in resolution for ...
Status: RESOLVED FIXED
Product: CSS
Classification: Unclassified
Component: CSS Level 2
unspecified
All All
: P2 normal
: ---
Assigned To: Bert Bos
:
Depends on:
Blocks:
  Show dependency treegraph
 
Reported: 2012-01-02 11:01 UTC by Anton P
Modified: 2012-09-13 10:40 UTC (History)
3 users (show)

See Also:


Attachments

Note You need to log in before you can comment on or make changes to this bug.
Description Anton P 2012-01-02 11:01:07 UTC
In the "Applies To" line of the 'overflow' property (http://www.w3.org/TR/CSS21/visufx.html#overflow), the value "block
containers" is incorrect and should be changed to "block containers and table boxes".  Originally, the value was "non-replaced
block-level elements, table cells, and inline-block elements" but was inaccurately changed in line with Issue 120 (http://wiki.csswg.org/spec/css2.1#issue-120 ; see below) as per the resolution to Issue 266 (http://wiki.csswg.org/spec/css2.1#issue-266 ; see below).

Conversation begins: http://lists.w3.org/Archives/Public/www-style/2011Dec/0014.html

Bug description: http://lists.w3.org/Archives/Public/www-style/2011Dec/0034.html

Acknowledgement: http://lists.w3.org/Archives/Public/www-style/2011Dec/0107.html


Issue 120

URL
    http://lists.w3.org/Archives/Public/www-style/2009Mar/0004.html (Issue 8)
Summary
    Spec talks about blocks but leaves out table-caption etc.
Proposal
    Define table-caption etc. to format their contents exactly like blocks, and remove all explicit lists (and just talk about blocks) elsewhere so we don't keep getting out-of-sync. http://lists.w3.org/Archives/Public/www-style/2010Aug/0399.html
Resolution
    Proposal accepted.
Follow-up 1
    There is probably an error[http://lists.w3.org/Archives/Public/www-style/2010Oct/0044.html] in the replacement text for bullet 2 in 10.2. Note that this replacement text anyway needs to change again, because of issue 142[http://wiki.csswg.org/spec/css2.1#issue-142].
Status
    Closed.
Testcases
    n/a (editorial)


Issue 266

Summary
    Issue 120 follow-up
URL
    http://lists.w3.org/Archives/Public/www-style/2011Jan/0079.html
Proposal :
    * Accept proposals 1 & 2 with “block container element” instead of “block container”
    accept 3
    accept 4
    accept 5 with s/which/that/
    accept 7 (but beware second set of edits applies to second quoted sentence, not first)

Resolution
    Accept issue 6 edits, push rest to errata.
Status
    Closed. =errata=
Comment 1 Gérard Talbot 2012-01-02 19:48:54 UTC
Related tests from CSS 2.1 test suite, Release Candidate 6
 
CSS Test: overflow applied to elements with 'display' set to 'table'
http://test.csswg.org/suites/css2.1/20110323/html4/overflow-applies-to-013.htm

CSS Test: overflow applied to elements with 'display' set to 'inline-table'
http://test.csswg.org/suites/css2.1/20110323/html4/overflow-applies-to-014.htm

IE 9, Firefox 9.0.1, Opera 11.60, Chrome 16.0.912.63 and Konqueror 4.7.4 will pass both these tests: they will not display any red.

regards, Gérard
Comment 2 Anton P 2012-02-04 17:41:42 UTC
This bug has a dependency on Bug 14763 ("Remove Applies-To lines").
Comment 3 fantasai 2012-05-14 20:14:33 UTC
Proposed text:
  http://lists.w3.org/Archives/Public/www-style/2012May/0494.html
Comment 4 Anton P 2012-05-20 15:09:39 UTC
Note that the proposal in Comment 3 is actually a proposal for Bug 17121 and Bug 17122 which happens to incorporate a fix this issue.  Hence the proposal has a dependency on those two issues.
Comment 5 Anton P 2012-06-24 09:54:13 UTC
The test described in Comment 1 don't actually test this specific issue, I think, because to test this issue meaningfully there needs to be at least one caption box present.

In [1], Øyvind Stenhaug presents the following test case, which seems to suggest that Gecko and IE8 apply overflow to the table box whereas WebKit applies it to the table wrapper box:

<!DOCTYPE HTML>
<title>overflow on table with caption</title>
<style>
    table {
       background: gray;
       caption-side: bottom;
       overflow: hidden;
    }
    caption {
       background: teal;
       height: 25px;
    }
    td > div {
       position: relative;
       width: 50px;
       height: 25px;
    }
    div > div {
       width: 100px;
       height: 100px;
       background: navy;
       position: absolute;
    }
</style>
<table>
    <caption></caption>
    <tr>
       <td><div><div></div></div></td>
    </tr>
</table>

This test case or something similar needs to go into the test suite.

[1] http://lists.w3.org/Archives/Public/www-style/2011Jul/0462
Comment 6 Anton P 2012-07-15 07:53:55 UTC
Regarding the proposal in Comment 3, Øyvind Stenhaug made the comment that "Applies to" is supposed to list the *elements* to which the property applies, not boxes.  (Whether that's actually what we want is an orthogonal question unlikely to be addressed for CSS21.)  No-one expressed any objection to hand-waving that issue away by blaming it on the spec-wide element vs box sloppiness.  See http://lists.w3.org/Archives/Public/www-style/2012May/0793.html

In fact, though, this bug has a dependency on http://lists.w3.org/Archives/Public/www-style/2012Jul/0338.html (not yet accepted as a Bug) which proposes to define "block container element" in CSS21.  If that happens, the proposal in Comment 3 can be rewritten in terms of elements not boxes:

  | Applies to: block container elements and elements that establish a
  | formatting context

Where as proposal in Comment 3 is expressed in terms of boxes and aims to "capture" table boxes via the second clause, the proposal above captures them via either clause, since a table element would be both a block container element (since its principal table wrapper box is a block container) and an element which establishes (not just one but) two formatting contexts.  The 'overflow' property itself has its effect on the table box not the table wrapper box, as per the property distribution rules in 17.4.

It doesn't seem worth making a change to the second clause without the change to the first clause though, since that just muddies the waters further by mixing elements and boxes in the same phrase.  Hence the dependency on defining "block container element".
Comment 7 Anton P 2012-07-15 09:08:23 UTC
I retract Comment 6.  The comment should have been added to Bug 17122.
Comment 8 Anton P 2012-07-15 09:16:40 UTC
The proposals for Bug 17121 and Bug 17122 have been accepted by the WG, reoving the dependency of this bug on those issues.

Note that the resolved text coming from Bug 17122 is:

  # Applies to: block containers and boxes that establish a formatting context

As described in Comment 4, that text incorporates a fix to this bug.

However, it is now questionable whether we want to fix this bug at all.  The WG resolved to specify the behaviour of the majority of major implementations.[1]

Accordingly, the resolved text from Bug 17122 now has a dependency on this bug.

Comment 5 contains a suitable test case.  The following test case may also be relevant: http://test.csswg.org/shepherd/testcase/overflow-applies-to-013/


[1] http://lists.w3.org/Archives/Public/www-style/2012Jun/0656.html
Comment 9 Anton P 2012-07-15 11:39:00 UTC
If we decide that we wish 'overflow' to have its effect on the table wrapper box, then 17.4 would need to be updated to say that, but no change would be needed to the "Applies To" line for 'overflow', neither in the newly-resolved text in Comment 8 nor in the current spec text described in Comment 1, since the table wrapper box is a block container.

If we decide that we wish 'overflow' to have its effect on the table box, then no change is needed to 17.4, and no change is needed to the "Applies To" line for 'overflow' with the newly-resolved text in Comment 8, since the table box establishes a table formatting context.  (However, a change would be needed to the existing spec text, unless we were to resolve in favour of the proposal in Comment number 6 in Bug 17122 which proposes to express the "Applies To" line in terms of elements instead of boxes, itself contingent on defining a table element to be a block container element.)

Hence this bug is resolved.

The issue of whether overflow should have its effect on the table box or the table wrapper box is the subject of Bug 17122 Comment number 6.
Comment 10 Anton P 2012-09-13 10:32:04 UTC
Correction: Comment 9 should have said:

The issue of whether overflow should have its effect on the table box or the
table wrapper box is the subject of Bug 17505 Comment number 6.
Comment 11 Anton P 2012-09-13 10:40:30 UTC
Closing this bug; as described in Comment 8 and Comment 9, a fix to this bug is incorporated into a fix to Bug 17122.